class Logger{constructor(e,t){this._id=e,this._level=Logger._toValue(t)}setLevel(e){this._level=Logger._toValue(e)}setId(e){this._id=e}debug(e){this._level>=Logger._DEBUG&&console.log(this._consoleText(e))}warn(e){this._level>=Logger._WARN&&console.warn(this._consoleText(e))}error(e){this._level>=Logger._ERROR&&console.error(this._consoleText(e))}static _toValue(e){const t=(e||"").toLowerCase();return"debug"===t||"trace"===t||"notice"===t?Logger._DEBUG:"info"===t?Logger._INFO:t.startsWith("warn")?Logger._WARN:t.startsWith("err")?Logger._ERROR:"fatal"===t?Logger._FATAL:Logger._OFF}_consoleText(e){return this._id?`[idc:${this._id}] ${e}`:`[idc] ${e}`}}Logger._OFF=0,Logger._FATAL=1,Logger._ERROR=2,Logger._WARN=3,Logger._INFO=4,Logger._DEBUG=5;class PositionInPixels{constructor(e,t){this.x=e,this.y=t}getRelativeCoord(e){return e.isUnknown()?new PositionInRelativeCoord:new PositionInRelativeCoord(this.x/e.getSafeWidth(),this.y/e.getSafeHeight())}toString(){return`{x=${this.x.toFixed(3)}px, y=${this.y.toFixed(3)}px}`}}class PositionInRelativeCoord{constructor(e,t){this._x=Math.max(Math.min(null!=e?e:0,1),0),this._y=Math.max(Math.min(null!=t?t:0,1),0)}getPositionInPixels(e){let t=0,i=0;return e.isUnknown()||(t=e.getWidth(),i=e.getHeight()),new PositionInPixels(this._x*t,this._y*i)}toString(){return`{x=${this._x.toFixed(3)}, y=${this._y.toFixed(3)}}`}}class SizeInRelativeCoord{constructor(e,t){this._width=Math.max(Math.min(null!=e?e:0,1),0),this._height=Math.max(Math.min(null!=t?t:0,1),0)}getSizeInPixels(e){let t=0,i=0;return e.isUnknown()||(t=e.getWidth(),i=e.getHeight()),new SizeInPixels(this._width*t,this._height*i)}toString(){return`{width=${this._width.toFixed(3)}, height=${this._height.toFixed(3)}}`}}class SizeInPixels{constructor(e,t){this._unknown=!0,this._width=0,this._height=0,null!=e&&null!=t&&(this._width=Math.max(e,0),this._height=Math.max(t,0),this._unknown=!1)}getWidth(){return this._width}getHeight(){return this._height}getSafeWidth(){return Math.max(this._width,1)}getSafeHeight(){return Math.max(this._height,1)}getSafeRatio(){return this.getSafeWidth()/this.getSafeHeight()}getScaled(e){if(this.isUnknown())return new SizeInPixels;const t=this._width*e,i=this._height*e;return new SizeInPixels(t,i)}isUnknown(){return this._unknown}setIfDifferent(e){return!this.equals(e)&&(this._unknown=e.isUnknown(),this._width=e.getWidth(),this._height=e.getHeight(),!0)}ratioDiffFactor(e){const t=this.getSafeRatio(),i=e.getSafeRatio();return t>=i?t/i:i/t}getRelativeCoord(e){return e.isUnknown()?new SizeInRelativeCoord:new SizeInRelativeCoord(this._width/e.getSafeWidth(),this._height/e.getSafeHeight())}toString(){return`{width=${this._width.toFixed(3)}px, height=${this._height.toFixed(3)}px}`}equals(e){return this._width===e.getWidth()&&this._height===e.getHeight()}}class RectangleImageRegion{static getTransformedImageSize(e,t){return e.getScaled(t.factor)}constructor(e,t,i){this.id=null!=e?e:"",this.position=null!=t?t:new PositionInRelativeCoord,this.size=null!=i?i:new SizeInRelativeCoord,this._unknown=!t||!i}setFields(e,t){var i,s;const n=e.shape?e.shape.toLowerCase():"rectangle";if("rectangle"!==n)return t.debug(`Region ${e.id} has unknown shape ${n}, skipping.`),void(this._unknown=!0);let o=null===(i=e.unit)||void 0===i?void 0:i.toLowerCase();if(o||(e.imageWidth&&e.imageHeight?o="pixel":e.imageWidth||e.imageHeight||(o="relative")),"relative"!==o&&"pixel"!==o)return t.debug(`Region ${e.id} has unknown unit ${o}, skipping.`),void(this._unknown=!0);let a=new SizeInPixels;if("pixel"===o){if(null==e.imageWidth||null==e.imageHeight)return t.warn(`Region ${e.id} has missing imageWidth or imageHeight, skipping.`),void(this._unknown=!0);a=new SizeInPixels(parseFloat(`${e.imageWidth}`),parseFloat(`${e.imageHeight}`))}if(null==e.x||null==e.y||null==e.width||null==e.height)return t.warn(`Region ${e.id} has missing x, y, width or height, skipping.`),void(this._unknown=!0);const r=parseFloat(`${e.x}`),l=parseFloat(`${e.y}`),g=parseFloat(`${e.width}`),h=parseFloat(`${e.height}`);return Number.isNaN(r)||Number.isNaN(l)||Number.isNaN(g)||Number.isNaN(h)?(t.warn(`Region ${e.id} has non-numeric x, y, width or height, skipping.`),void(this._unknown=!0)):r<0||l<0||g<=0||h<=0?(t.warn(`Region ${e.id} has negative/zero x, y, width or height, skipping.`),void(this._unknown=!0)):("relative"===o?(this.position=new PositionInRelativeCoord(r,l),this.size=new SizeInRelativeCoord(g,h)):(this.position=new PositionInPixels(r,l).getRelativeCoord(a),this.size=new SizeInPixels(g,h).getRelativeCoord(a)),this.id=null!==(s=e.id)&&void 0!==s?s:window.crypto.randomUUID(),void(this._unknown=!1))}isUnknown(){return this._unknown}getTransformation(e,t,i){const s=this.position.getPositionInPixels(t),n=this.size.getSizeInPixels(t),o=n.getSafeWidth(),a=n.getSafeHeight(),r=e.getSafeWidth(),l=e.getSafeHeight(),g=t.getWidth(),h=t.getHeight(),d=g-o-s.x,_=h-a-s.y;let u=0,c=0,m=1;if(e.getSafeRatio()<n.getSafeRatio()){m=r/o,c=(l/m-a)/2;(c-s.y>0||c-_>0)&&(c=Math.min(s.y,_),m=l/(2*c+a),u=(r/m-o)/2)}else{m=l/a,u=(r/m-o)/2;(u-s.x>0||u-d>0)&&(u=Math.min(s.x,d),m=r/(2*u+o),c=(l/m-a)/2)}const b=new PositionInPixels(s.x-u,s.y-c);return{origin:b,factor:m,insetClipFromTopLeft:new SizeInPixels(b.x,b.y),insetClipFromBottomRight:new SizeInPixels(d-u+i.getWidth(),_-c+i.getHeight())}}getBoundingBox(e,t,i){const s=new PositionInPixels(-i.origin.x*i.factor,-i.origin.y*i.factor),n=RectangleImageRegion.getTransformedImageSize(t,i),o=this.position.getPositionInPixels(n);return{position:new PositionInPixels(o.x+s.x,o.y+s.y),size:this.size.getSizeInPixels(n)}}}class ImageDisplayControl extends HTMLImageElement{constructor(){super(...arguments),this._rectangleImageRegions=[],this._sizeObserver=null,this._elementSize=new SizeInPixels,this._fittedImageSize=new SizeInPixels,this._fittedImageBottomRightMargin=new SizeInPixels,this._parentElement=null,this._parentCssContainToRestore=null,this._parentCssOverflowToRestore=null,this._sizesAttributeToRestore=null,this._sizesAttributeDebounceTimer=null,this._sizesAttributeLastSet=null,this._cssBorderToRestore=null,this._cssPaddingToRestore=null,this._logger=new Logger(this.id,this.dataset.loglevel),this._browserFeatures={cssInset:!1,resizeObserver:!1,cssContain:!1},this._debugRegionOverlayContainer=null,this._debugRegionOverlays=new Map,this._debugRegionOverlayStyles=["5px solid rgba(240, 69, 141, 0.7)","5px solid rgba(127, 15, 130, 0.7)","5px solid rgba(48, 0, 150, 0.7)"]}static get observedAttributes(){return["id","src","srcset","data-loglevel","data-disabled","data-image-regions","data-image-region-id","data-avoid-no-region","data-debug-draw-regions","data-css-contain-fallback"]}connectedCallback(){this._logger.debug("Connected"),this._registerImageLoadedLateCallback(),this._behaviorChanged()}disconnectedCallback(){this._logger.debug("Disconnected"),this._unregisterImageLoadedLateCallback(),this._restoreOriginalParentCssContainment()}attributeChangedCallback(e){switch(e){case"id":this._logger.setId(this.id);break;case"src":case"srcset":this._isDisabled()||(this._registerImageLoadedLateCallback(),this._populateFittedImageSize(),this._panAndZoomToBestRegion());break;case"data-loglevel":this._logger.setLevel(this.dataset.loglevel);break;case"data-disabled":case"data-debug-draw-regions":case"data-css-contain-fallback":this._behaviorChanged();break;case"data-image-regions":this._populateRectangleImageRegions(),this._isDisabled()||(this._resetDebugRegionOverlays(),this._panAndZoomToBestRegion());break;case"data-image-region-id":case"data-avoid-no-region":this._isDisabled()||this._panAndZoomToBestRegion();break;default:this._logger.warn(`Unexpected attribute mutation: ${e}`)}}_getInternal(expr){return eval(expr)}_behaviorChanged(){this._populateBrowserFeatures(),this._isDisabled()?(this._unregisterImageLoadedLateCallback(),this._logger.debug("Disabled"),this._sizeObserver&&(this._sizeObserver.unobserve(this),this._sizeObserver=null),this._setDebounceSizesAttribute(),this._restoreOriginalBorderAndPadding(),this._removeDebugRegionOverlays(),this._setCssToMiddleCropOriginalImage(),this._restoreOriginalParentCssContainment()):(this._logger.debug("Enabled"),this._adaptParentCssContainment(),this._resetDebugRegionOverlays(),this._panAndZoomToBestRegion(),this._sizeObserver||(this._sizeObserver=new ResizeObserver(this._resizeCallback.bind(this)),this._sizeObserver.observe(this)))}_resizeCallback(e){if(this._isDisabled())return void this._logger.warn("Component disabled, spurious call to _resizeCallback()");const t=e.pop();if(!t)return void this._logger.warn("No ResizeObserverEntry, spurious call to _resizeCallback()");if(t.target!==this)return void this._logger.warn("Unexpected ResizeObserverEntry target");let i=new SizeInPixels;i=t.contentBoxSize?new SizeInPixels(t.contentBoxSize[0].inlineSize,t.contentBoxSize[0].blockSize):new SizeInPixels(t.contentRect.width,t.contentRect.height);this._elementSize.setIfDifferent(i)&&(this._logger.debug(`Element size: ${this._elementSize}`),this._populateFittedImageSize(),this._panAndZoomToBestRegion())}_imageLoadedLateCallback(){this._unregisterImageLoadedLateCallback(),this._logger.debug("Image loaded late"),this._populateFittedImageSize(),this._panAndZoomToBestRegion()}_registerImageLoadedLateCallback(){this._logger.debug('Registering "Image loaded late" callback...'),this.addEventListener("load",this._imageLoadedLateCallback)}_unregisterImageLoadedLateCallback(){this._logger.debug('Unregistering "Image loaded late" callback...'),this.removeEventListener("load",this._imageLoadedLateCallback)}_populateRectangleImageRegions(){this._logger.debug("Populating rectangle image regions..."),this._rectangleImageRegions=[];let e=[],t=!1;try{e=JSON.parse(this.dataset.imageRegions||"[]")}catch(e){t=!0}t||(t=!Array.isArray(e)),t&&(this._logger.warn("Invalid 'data-image-regions' attribute"),e=[]),e.forEach((e=>{const t=new RectangleImageRegion;t.setFields(e,this._logger),t.isUnknown()||(this._logger.debug(`Rectangle region found: id=${t.id}, position=${t.position}, size=${t.size}`),this._rectangleImageRegions.push(t))})),this._rectangleImageRegions.length||this._logger.debug("No rectangle image region found")}_populateFittedImageSize(){if(this.naturalWidth<=0&&this.naturalHeight<=0)return void this._logger.debug("Natural image size unknown, deferring.");const e=new SizeInPixels(this.naturalWidth,this.naturalHeight);let t=1;t=this._elementSize.getSafeRatio()<e.getSafeRatio()?this._elementSize.getSafeWidth()/e.getSafeWidth():this._elementSize.getSafeHeight()/e.getSafeHeight(),this._fittedImageSize=new SizeInPixels(this.naturalWidth*t,this.naturalHeight*t),this._fittedImageBottomRightMargin=new SizeInPixels(this._elementSize.getWidth()-this._fittedImageSize.getWidth(),this._elementSize.getHeight()-this._fittedImageSize.getHeight()),this._logger.debug(`Fitted image size: ${this._fittedImageSize}`),this._logger.debug(`Fitted image margin: ${this._fittedImageBottomRightMargin}`)}_panAndZoomToBestRegion(){if(this._logger.debug("Panning and zooming to best region..."),this._fittedImageSize.isUnknown())return void this._logger.debug("Fitted image size unknown, deferring.");let e=null;if(this.dataset.imageRegionId&&(e=this.dataset.imageRegionId===ImageDisplayControl._ORIGINAL_IMAGE_REGION.id?ImageDisplayControl._ORIGINAL_IMAGE_REGION:this._rectangleImageRegions.find((e=>e.id===this.dataset.imageRegionId))),e||(e=this._findBestRegion()),ImageDisplayControl._ORIGINAL_IMAGE_REGION.id!==e.id||this._debugRegionOverlayContainer){null===this._cssBorderToRestore&&(this._cssBorderToRestore=this.style.border,this.style.border="none"),null===this._cssPaddingToRestore&&(this._cssPaddingToRestore=this.style.padding,this.style.padding="0");const t=e.getTransformation(this._elementSize,this._fittedImageSize,this._fittedImageBottomRightMargin);if(this._setCssToPanAndZoomToRegion(t),this._debugRegionOverlayContainer&&this._drawDebugRegionOverlays(t),this.srcset.length>0&&this.sizes.length>0){const e=RectangleImageRegion.getTransformedImageSize(this._fittedImageSize,t).getWidth();this._setDebounceSizesAttribute(e)}}else this._setDebounceSizesAttribute(),this._restoreOriginalBorderAndPadding(),this._setCssToMiddleCropOriginalImage()}_findBestRegion(){let e=ImageDisplayControl._ORIGINAL_IMAGE_REGION,t=this._elementSize.ratioDiffFactor(this._fittedImageSize);return this._logger.debug(`Element ratio: ${this._elementSize.getSafeRatio().toFixed(3)}`),this._logger.debug(`Original image ratio: ${this._fittedImageSize.getSafeRatio().toFixed(3)}`),this.dataset.avoidNoRegion&&"off"===this.dataset.avoidNoRegion||(t=999),t>1.1&&this._rectangleImageRegions.forEach((i=>{const s=i.size.getSizeInPixels(this._fittedImageSize);this._logger.debug(`${i.id} region ratio: ${s.getSafeRatio().toFixed(3)}`);const n=this._elementSize.ratioDiffFactor(s);n<t&&(t=n,e=i)})),this._logger.debug(`Selected region: ${e.id}`),e}_adaptParentCssContainment(){const e=this._currentCssContainmentStrategy();"none"!==e?(this._parentElement=this.parentElement,this._parentElement&&("contain"===e?("paint"!==this._parentElement.style.contain&&"layout"!==this._parentElement.style.contain&&"content"!==this._parentElement.style.contain&&(null===this._parentCssContainToRestore&&(this._parentCssContainToRestore=this._parentElement.style.contain),this._parentElement.style.contain="paint"),this._restoreOriginalParentCssOverflow()):"overflow"===e&&("hidden"!==this._parentElement.style.overflow&&"clip"!==this._parentElement.style.overflow&&(null===this._parentCssOverflowToRestore&&(this._parentCssOverflowToRestore=this._parentElement.style.overflow),this._parentElement.style.overflow="hidden"),this._restoreOriginalParentCssContain()))):this._restoreOriginalParentCssContainment()}_restoreOriginalParentCssContainment(){this._restoreOriginalParentCssContain(),this._restoreOriginalParentCssOverflow()}_restoreOriginalParentCssContain(){this._parentElement&&null!==this._parentCssContainToRestore&&(this._parentElement.style.contain=this._parentCssContainToRestore,this._parentCssContainToRestore=null)}_restoreOriginalParentCssOverflow(){this._parentElement&&null!==this._parentCssOverflowToRestore&&(this._parentElement.style.overflow=this._parentCssOverflowToRestore,this._parentCssOverflowToRestore=null)}_setDebounceSizesAttribute(e){null!==this._sizesAttributeDebounceTimer&&clearTimeout(this._sizesAttributeDebounceTimer);this._sizesAttributeDebounceTimer=void 0!==e?window.setTimeout((()=>{if(this._sizesAttributeDebounceTimer=null,null===this._sizesAttributeToRestore&&(this._sizesAttributeToRestore=this.sizes),null===this._sizesAttributeLastSet||this._sizesAttributeLastSet<e){this._unregisterImageLoadedLateCallback();const t=`${Math.ceil(e)}px`;this._logger.debug(`Increasing sizes= to ${t}`),this.sizes=t,this._sizesAttributeLastSet=e}}),200):window.setTimeout((()=>{this._sizesAttributeDebounceTimer=null,null!==this._sizesAttributeToRestore&&(this._unregisterImageLoadedLateCallback(),this._logger.debug(`Resetting sizes= to ${this._sizesAttributeToRestore}`),this.sizes=this._sizesAttributeToRestore,this._sizesAttributeToRestore=null),this._sizesAttributeLastSet=null}),200)}_restoreOriginalBorderAndPadding(){null!==this._cssBorderToRestore&&(this.style.border=this._cssBorderToRestore,this._cssBorderToRestore=null),null!==this._cssPaddingToRestore&&(this.style.padding=this._cssPaddingToRestore,this._cssPaddingToRestore=null)}_setCssToMiddleCropOriginalImage(){this.style.objectFit="cover",this.style.objectPosition="center",this.style.transformOrigin="0 0",this.style.transform="none",this.style.clipPath="none"}_setCssToPanAndZoomToRegion(e){this.style.objectFit="contain",this.style.objectPosition="top left",this.style.transformOrigin=`${e.origin.x.toFixed(3)}px ${e.origin.y.toFixed(3)}px`,this.style.transform=`translate(${-e.origin.x.toFixed(3)}px, ${-e.origin.y.toFixed(3)}px) scale(${e.factor.toFixed(3)})`,this.style.clipPath=`inset(${e.insetClipFromTopLeft.getHeight()}px ${e.insetClipFromBottomRight.getWidth()}px ${e.insetClipFromBottomRight.getHeight()}px ${e.insetClipFromTopLeft.getWidth()}px)`}_resetDebugRegionOverlays(){"on"===(this.dataset.debugDrawRegions||"off")?this._recreateEmptyDebugRegionOverlays():this._removeDebugRegionOverlays()}_recreateEmptyDebugRegionOverlays(){var e;this._debugRegionOverlayContainer&&this._removeDebugRegionOverlays(),this._debugRegionOverlayContainer=document.createElement("div"),this._debugRegionOverlayContainer.style.position="absolute",null===(e=this._parentElement)||void 0===e||e.insertBefore(this._debugRegionOverlayContainer,this)}_removeDebugRegionOverlays(){var e;this._debugRegionOverlayContainer&&(null===(e=this._parentElement)||void 0===e||e.removeChild(this._debugRegionOverlayContainer),this._debugRegionOverlayContainer=null),this._debugRegionOverlays.clear()}_drawDebugRegionOverlays(e){this._rectangleImageRegions.forEach((t=>{this._drawDebugRegionOverlay(t,e)}))}_drawDebugRegionOverlay(e,t){var i;let s=this._debugRegionOverlays.get(e.id);s||(s=document.createElement("div"),s.style.position="absolute",s.style.boxSizing="border-box",s.style.border=this._pickNextOvelayStyle(),s.style.zIndex="999",null===(i=this._debugRegionOverlayContainer)||void 0===i||i.appendChild(s),this._debugRegionOverlays.set(e.id,s));const n=e.getBoundingBox(this._elementSize,this._fittedImageSize,t);s.style.left=`${n.position.x}px`,s.style.top=`${n.position.y}px`,s.style.width=`${n.size.getWidth()}px`,s.style.height=`${n.size.getHeight()}px`}_pickNextOvelayStyle(){const e=this._debugRegionOverlayStyles.shift()||"5px solid rgba(255, 0, 0, 0.7)";return this._debugRegionOverlayStyles.push(e),e}_populateBrowserFeatures(){const e=CSS.supports("clip-path: inset(5px)");e||this._logger.error("CSS `clip-path: inset()` is not supported. Disabling the web component");const t="undefined"!=typeof ResizeObserver;t||this._logger.error("ResizeObserver is not supported. Disabling the web component. Consider using a polyfill like  https://github.com/juggle/resize-observer");const i=CSS.supports("contain: paint");i||this.dataset.cssContainFallback||this._logger.warn("CSS containment is not supported. Consider using the `css-contain-fallback=` attribute"),this._browserFeatures={cssInset:e,resizeObserver:t,cssContain:i}}_cssContainFallbackStrategy(){return"disable-containment"===this.dataset.cssContainFallback||"overflow-hidden"===this.dataset.cssContainFallback||"force"===this.dataset.cssContainFallback?this.dataset.cssContainFallback:"disable-component"}_isDisabled(){return"all"===this.dataset.disabled||!this._browserFeatures.cssInset||!this._browserFeatures.resizeObserver||this._isCssContainUnsupportedOrDisabled()&&"disable-component"===this._cssContainFallbackStrategy()}_isCssContainUnsupportedOrDisabled(){return!this._browserFeatures.cssContain||"css-contain"===this.dataset.disabled}_currentCssContainmentStrategy(){if(this._isDisabled())return"none";if(!this._isCssContainUnsupportedOrDisabled())return"contain";const e=this._cssContainFallbackStrategy();return"overflow-hidden"===e?"overflow":"disable-containment"===e?"none":"contain"}}ImageDisplayControl._ORIGINAL_IMAGE_REGION=new RectangleImageRegion("<no region>",new PositionInRelativeCoord(0,0),new SizeInRelativeCoord(1,1)),window.customElements.define("image-display-control",ImageDisplayControl,{extends:"img"});
